! Here's the prototype:
!   CB_MessageRewrite      FUNCTION(STRING,<STRING>,<STRING>,<STRING>,UNSIGNED=0,BOOL=FALSE),UNSIGNED,PROC
!
! You can plug this function into your Clarion code with the following line
!   SYSTEM{PROP:MessageHook}=ADDRESS(CB_MessageRewrite)
!
! Thanks,
!
! Harley (hjones@sti-k12.com)
!
!
CB_MessageRewrite    PROCEDURE  (pMessage,pCaption,pImage,pButtons,pDefaultButton,pStyle)
TheWindow              WINDOW(' '),AT(,,5,5),CENTER,GRAY,FONT('MS Sans Serif',8)
                         PROMPT('message'),USE(?Text)
                         IMAGE,AT(5,15),USE(?Image),HIDE
                         BUTTON,AT(,,50,14),USE(?Button1),HIDE
                         BUTTON,AT(,,50,14),USE(?Button2),HIDE
                         BUTTON,AT(,,50,14),USE(?Button3),HIDE
                         BUTTON,AT(,,50,14),USE(?Button4),HIDE
                         BUTTON,AT(,,50,14),USE(?Button5),HIDE
                         BUTTON,AT(,,50,14),USE(?Button6),HIDE
                         BUTTON,AT(,,50,14),USE(?Button7),HIDE
                         BUTTON,AT(,,50,14),USE(?Button8),HIDE
                       END

UsesImage              BOOL,AUTO
UsesButtonEquates      BOOL,AUTO

Buttons                QUEUE,PRE(Buttons)
Feq                      SIGNED
Text                     STRING(20)
EquateValue              UNSIGNED
                       END

PressedButton          UNSIGNED,AUTO
retval                 UNSIGNED,AUTO

WindowXpos             UNSIGNED,AUTO
WindowYpos             UNSIGNED,AUTO
WindowWidth            UNSIGNED,AUTO
WindowHeight           UNSIGNED,AUTO

ImageXpos              UNSIGNED,AUTO
ImageYpos              UNSIGNED,AUTO
ImageWidth             UNSIGNED,AUTO
ImageHeight            UNSIGNED,AUTO

TextXpos               UNSIGNED,AUTO
TextYpos               UNSIGNED,AUTO
TextWidth              UNSIGNED(0)
TextHeight             UNSIGNED(0)
  CODE
  OPEN(TheWindow)
  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow
      0{PROP:Hide}=True
      DO SetupCaption
      DO SetupImage
      DO SetupMessage
      DO SetupButtons
      DO SetupDefaultButton
      DO SetupStyle
      GETPOSITION(0,WindowXpos,WindowYpos,WindowWidth,WindowHeight)
      WindowXpos-=WindowWidth/2
      WindowYpos-=WindowHeight/2
      SETPOSITION(0,WindowXpos,WindowYpos,WindowWidth,WindowHeight)
      0{PROP:Hide}=False
    OF EVENT:Accepted
      PressedButton=FIELD()
      GET(Buttons,0)
      LOOP 
        GET(Buttons,POINTER(Buttons)+1)
        IF ERRORCODE() OR PressedButton=Buttons.Feq
          BREAK
        END
      END
      IF UsesButtonEquates
        retval=Buttons.EquateValue
      ELSE
        retval=POINTER(Buttons)
      END
      POST(EVENT:CloseWindow)
    END
  END
  CLOSE(TheWindow)
  RETURN retval
SetupCaption         ROUTINE
  IF pCaption AND NOT OMITTED(2)
    0{PROP:Text}=pCaption
  END
SetupImage           ROUTINE
  IF NOT pImage OR OMITTED(3)
    UsesImage=False
  ELSE
    UsesImage=True
    ?Image{PROP:Hide}=False
    ?Image{PROP:Text}=pImage
    GETPOSITION(?Image,ImageXpos,ImageYpos,ImageWidth,ImageHeight)
    SETPOSITION(0,,,ImageXpos+ImageWidth,ImageYpos+ImageHeight)
  END
SetupMessage         ROUTINE
  DATA
StrStart               UNSIGNED(1)
StrEnd                 UNSIGNED,AUTO
TempTextWidth          UNSIGNED,AUTO
TempTextHeight         UNSIGNED,AUTO
Lines                  UNSIGNED(1)
NewMessage             &STRING
TmpString              &STRING
  CODE
  NewMessage &= NEW STRING(LEN(pMessage))
  GETPOSITION(0,,,WindowWidth,WindowHeight)
  LOOP
    StrEnd=INSTRING('|',pMessage,1,StrStart)
    IF StrEnd=0
      BREAK
    END
    ?Text{PROP:Text}=pMessage[StrStart : StrEnd-1]&'<13,10>'
    GETPOSITION(?Text,,,TempTextWidth,TempTextHeight)
    TempTextHeight-=2
    IF TextWidth<TempTextWidth
      TextWidth=TempTextWidth
    END
    IF TextHeight<TempTextHeight
      TextHeight=TempTextHeight
    END

    TmpString &= NewMessage
    NewMessage &= NEW STRING(LEN(TmpString)+1)
    NewMessage=CLIP(TmpString)&pMessage[StrStart : StrEnd-1]&'<13,10>'
    DISPOSE(TmpString)

    Lines+=1
    StrStart=StrEnd+1
  END
  ?Text{PROP:Text}=pMessage[StrStart : LEN(CLIP(pMessage))]
  GETPOSITION(?Text,,,TempTextWidth,TempTextHeight)
  TempTextHeight-=2
  IF TextWidth<TempTextWidth
    TextWidth=TempTextWidth
  END
  IF TextHeight<TempTextHeight
    TextHeight=TempTextHeight
  END
  ?Text{PROP:Text}=CLIP(NewMessage)&pMessage[StrStart : LEN(CLIP(pMessage))]
  DISPOSE(NewMessage)
  TextHeight*=Lines
  IF TextHeight>WindowHeight
    WindowHeight=TextHeight+10
  END
  IF TextWidth>WindowWidth
    WindowWidth=TextWidth+10
    IF UsesImage
      WindowWidth+=(ImageXpos+ImageWidth)
    END
  END
  IF UsesImage
    TextXpos=(ImageXpos+ImageWidth)+10
    IF TextHeight<ImageHeight
      TextYpos=ImageYpos+(ImageHeight/2)-(TextHeight/2)
    ELSE
      TextYpos=(WindowHeight/2)-(TextHeight/2)
    END
  ELSE
    TextXpos=(WindowWidth/2)-(TextWidth/2)
    TextYpos=(WindowHeight/2)-(TextHeight/2)
  END
  SETPOSITION(?Text,TextXpos,TextYpos,TextWidth,TextHeight)
  SETPOSITION(0,,,WindowWidth+15,WindowHeight)
SetupButtons         ROUTINE
  DATA
StrStart               UNSIGNED(1)
StrEnd                 UNSIGNED,AUTO
  CODE
  FREE(Buttons)
  CLEAR(Buttons)
  IF NOT pButtons OR OMITTED(4) OR NUMERIC(pButtons)
    UsesButtonEquates=True
    IF NOT pButtons OR OMITTED(4)
      Buttons.Text='OK'
      Buttons.EquateValue=BUTTON:OK
      DO AddButton
    ELSE
      IF BAND(pButtons,BUTTON:OK)
        Buttons.Text='OK'
        Buttons.EquateValue=BUTTON:OK
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:YES)
        Buttons.Text='&Yes'
        Buttons.EquateValue=BUTTON:YES
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:NO)
        Buttons.Text='&No'
        Buttons.EquateValue=BUTTON:NO
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:ABORT)
        Buttons.Text='&Abort'
        Buttons.EquateValue=BUTTON:ABORT
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:RETRY)
        Buttons.Text='&Retry'
        Buttons.EquateValue=BUTTON:RETRY
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:IGNORE)
        Buttons.Text='&Ignore'
        Buttons.EquateValue=BUTTON:IGNORE
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:CANCEL)
        Buttons.Text='Cancel'
        Buttons.EquateValue=BUTTON:CANCEL
        DO AddButton
      END
      IF BAND(pButtons,BUTTON:HELP)
        Buttons.Text='&Help'
        Buttons.EquateValue=BUTTON:HELP
        DO AddButton
      END
    END
  ELSE
    UsesButtonEquates=False
    LOOP 8 TIMES
      StrEnd=INSTRING('|',pButtons,1,StrStart)
      IF StrEnd=0
        Buttons.Text=pButtons[StrStart : LEN(pButtons)]
        DO AddButton
        BREAK
      END
      Buttons.Text=pButtons[StrStart : StrEnd-1]
      DO AddButton
      StrStart=StrEnd+1
    END
  END
  DO PositionButtons
AddButton            ROUTINE
  Buttons.Feq=?Button1+RECORDS(Buttons)
  ADD(Buttons)
  Buttons.Feq{PROP:Text}=Buttons.Text
  Buttons.Feq{PROP:Hide}=False
PositionButtons      ROUTINE
  DATA
MaxButtonXpos          UNSIGNED,AUTO
MaxButtonYpos          UNSIGNED(0)

ButtonXpos             UNSIGNED,AUTO
ButtonYpos             UNSIGNED,AUTO
ButtonWidth            UNSIGNED,AUTO
ButtonHeight           UNSIGNED,AUTO

ButtonSeparator        BYTE(5)
ButtonsPerRow          BYTE(4)
  CODE
  GETPOSITION(0,,,WindowWidth,WindowHeight)
  GETPOSITION(?Button1,,,ButtonWidth,ButtonHeight)
  IF RECORDS(Buttons)>ButtonsPerRow
    MaxButtonXpos=(ButtonsPerRow*ButtonWidth)+((ButtonsPerRow-1)*ButtonSeparator)
  ELSE
    MaxButtonXpos=(RECORDS(Buttons)*ButtonWidth)+((RECORDS(Buttons)-1)*ButtonSeparator)
  END
  IF MaxButtonXpos>WindowWidth THEN
    WindowWidth=MaxButtonXpos+15
  END
  ButtonXpos=(WindowWidth/2)-(MaxButtonXpos/2)
  ButtonYpos=(TextYpos+TextHeight)+15
  GET(Buttons,0)
  LOOP
    GET(Buttons,POINTER(Buttons)+1)
    IF ERRORCODE()
      BREAK
    END
    IF POINTER(Buttons)=ButtonsPerRow+1
      ButtonXpos=(WindowWidth/2)-((((RECORDS(Buttons)-ButtonsPerRow)*ButtonWidth)+((RECORDS(Buttons)-(ButtonsPerRow+1))*ButtonSeparator))/2)
      ButtonYpos+=ButtonHeight+ButtonSeparator
    END
    SETPOSITION(Buttons.Feq,ButtonXpos,ButtonYpos,ButtonWidth,ButtonHeight)
    IF ButtonXpos+ButtonWidth>MaxButtonXpos
      MaxButtonXpos=ButtonXpos+ButtonWidth
    END
    IF ButtonYpos+ButtonHeight>MaxButtonYpos
      MaxButtonYpos=ButtonYpos+ButtonHeight
    END
    ButtonXpos+=ButtonWidth+ButtonSeparator
  END
  IF MaxButtonXpos>WindowWidth
    WindowWidth=MaxButtonXpos
  END
  IF MaxButtonYpos>WindowHeight
    WindowHeight=MaxButtonYpos+ButtonSeparator
  END
  SETPOSITION(0,,,WindowWidth,WindowHeight)
SetupDefaultButton   ROUTINE
  IF NOT pDefaultButton OR OMITTED(5)
    GET(Buttons,1)
    Buttons.Feq{PROP:Default}=True
  ELSE
    IF UsesButtonEquates
      GET(Buttons,0)
      LOOP
        GET(Buttons,POINTER(Buttons)+1)
        IF ERRORCODE() OR Buttons.EquateValue=pDefaultButton
          BREAK
        END
      END
      Buttons.Feq{PROP:Default}=True
    ELSE
      GET(Buttons,pDefaultButton)
      Buttons.Feq{PROP:Default}=True
    END
  END
SetupStyle           ROUTINE
  DATA
STYLE                  ITEMIZE(0),PRE(STYLE)
AppModal                 EQUATE
SysModal                 EQUATE
                       END
  CODE
  IF NOT pStyle OR OMITTED(6) OR pStyle=STYLE:AppModal
    !The Window is already set to MODAL and PROP:Modal is Readonly anyway
  ELSE
    !System-Modal windows are not allowed in 32-bit programming
  END
